package net.t2code.t2codelib.VELOCITY.api.pluginMessaging.autoResponse;


import com.velocitypowered.api.event.Subscribe;
import com.velocitypowered.api.event.connection.PluginMessageEvent;
import com.velocitypowered.api.proxy.Player;
import com.velocitypowered.api.proxy.ProxyServer;
import net.t2code.t2codelib.VELOCITY.api.commands.T2CVcmd;
import net.t2code.t2codelib.VELOCITY.api.messages.T2CVsend;
import net.t2code.t2codelib.VELOCITY.system.T2CodeVMain;
import org.slf4j.Logger;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.IOException;

public class T2CapiAutoResponse {
    public static ProxyServer server = T2CodeVMain.server;
    public static Logger logger = T2CodeVMain.logger;

    @Subscribe
    public void onPluginmessage(PluginMessageEvent event) {
        if (event.getIdentifier() != T2CodeVMain.aresp) {
            return;
        }
        DataInputStream stream = new DataInputStream(new ByteArrayInputStream(event.getData()));

        try {
            String channel = stream.readUTF();
            String input = stream.readUTF();

            switch (channel) {
                case "ConC":
                    logger.info("Command Console: {}", input);
                    T2CVcmd.Console(input);
                    break;
                case "ALLPMSG":
                    for (Player player : server.getAllPlayers()) {
                        T2CVsend.player(player, input);
                    }
                    break;
                default:
                    Player player = server.getPlayer(channel).orElse(null);
                    if (player != null) {
                        logger.info("Command Console: {}", input);
                        T2CVcmd.Player(player, input);
                    }
                    break;
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

    }
}
