package net.t2code.t2codelib.VELOCITY.api.update;

import com.velocitypowered.api.command.CommandSource;

import com.velocitypowered.api.plugin.PluginContainer;
import com.velocitypowered.api.proxy.ProxyServer;
import net.t2code.t2codelib.T2CVupdateObject;
import net.t2code.t2codelib.T2CupdateWebData;
import net.t2code.t2codelib.UpdateType;
import net.t2code.t2codelib.VELOCITY.api.messages.T2CVsend;
import net.t2code.t2codelib.VELOCITY.system.T2CodeVMain;

import java.util.HashMap;
import java.util.Optional;

public class T2CVupdateAPI {
    public static HashMap<Optional<String>, T2CVupdateObject> bungeePluginVersins = new HashMap<>();
    public static ProxyServer server = T2CodeVMain.server;


    public static void sendUpdateMsg(String prefix, String discord, T2CupdateWebData webData, Optional<PluginContainer> plugin, CommandSource sender) {
        String publicVersion = webData.getVersion();
        String pluginVersion = String.valueOf(plugin.get().getDescription().getVersion());
        String value;
        if (webData.isPreRelease()) {
            value = UpdateType.PRERELEASE.text;
            if (publicVersion.toLowerCase().contains("dev")) {
                value = UpdateType.DEVELOPMENT.text;
            }
            if (publicVersion.toLowerCase().contains("beta")) {
                value = UpdateType.BETA.text;
            }
            if (publicVersion.toLowerCase().contains("snapshot")) {
                value = UpdateType.SNAPSHOT.text;
            }
        } else value = UpdateType.STABLE.text;
        String h = "<br><dark_red>╔══════════════</dark_red>" + prefix + "<dark_red>══════════════</dark_red>";
        String s1 = "<br><dark_red>║</dark_red> <gold>A new [value] version was found!</gold>".replace("[value]", value);
        String s2 = "<br><dark_red>║</dark_red> <gold>Your version: <red>" + pluginVersion + "</red> <gray>-</gray> Current version:</gold> <green>" + webData.getVersion() + "</green>";
        String s3 = "<br><dark_red>║</dark_red> <gold>You can download it here:</gold> <yellow>" + webData.getUpdateUrl() + "</yellow>";
        String s4 = "<br><dark_red>║</dark_red> <gold>You can find more information on Discord:</gold> <yellow>" + discord + "</yellow>";
        String f = "<br><dark_red>╚══════════════</dark_red>" + prefix + "<dark_red>══════════════</dark_red>";
        String text = h + s1 + s2 + s3 + s4 + f;
        if (sender == null) {
            T2CVsend.console(text);
        } else T2CVsend.sender(sender, text);

    }

    private static Boolean noUpdate = true;
    private static String pluginVersion;


    public static void checkForUpdates(Optional<PluginContainer> plugin, String prefix, String discord, Integer spigotID, String url) {

      //  if (T2CVlibConfig.getUpdateCheckFullDisable()) return;
        (new T2CVupdateCheckerGit(plugin, spigotID)).getVersion((webData) -> {
            pluginVersion = T2CodeVMain.version;
            T2CVupdateObject update = new T2CVupdateObject(
                    plugin.get().getDescription().getName(),
                    plugin.get().getDescription().getVersion(),
                    webData,
                    false,
                    !plugin.get().getDescription().getVersion().equals(webData.getVersion()),
                    true
            );
            bungeePluginVersins.put(plugin.get().getDescription().getName(), update);
            if (!pluginVersion.replace("_Bungee", "").equalsIgnoreCase(webData.getVersion())) {
                sendUpdateMsg(prefix, discord, webData, plugin, null);
                noUpdate = true;
            } else {
                if (noUpdate) {
                    T2CVsend.console(prefix + " §2No update found.");
                    noUpdate = false;
                }
            }
        }, pluginVersion, spigotID, url);
    }
}
